#include "md4.h"
#include <stdio.h>
#include <string.h>

#define BSSID_SIZE (6)
#define BSSID_HASH_SIZE (4)

void get_bssid(char *essid, unsigned int channel, unsigned char *bssid) {
	MD4_CTX ctx;
	unsigned char res[16];
	unsigned int i;

	MD4_Init(&ctx);
	MD4_Update(&ctx, essid, strlen(essid));
	MD4_Final(res, &ctx);

	for (i = 0; i < BSSID_HASH_SIZE; i++) {
		bssid[i] = res[i];
	}

	bssid[BSSID_HASH_SIZE] = (channel & 0xFF);
	bssid[BSSID_HASH_SIZE+1] = ((channel >> 8) & 0xFF);
}

int main(int argc, char *argv[]) {
	unsigned char bssid[BSSID_SIZE];
	unsigned int i;

	if (argc < 3) {
		printf("usage: ./program essid channel\n");
		return 0;
	}

	get_bssid(argv[1], atoi(argv[2]), bssid);

	for (i = 0; i < BSSID_SIZE; i++) {
		printf("%2x ", bssid[i]);
	}

	printf("\n");

	return 0;
}

